Welcome to mirror list, hosted at ThFree Co, Russian Federation.

git.kernel.org/pub/scm/git/git.git - Unnamed repository; edit this file 'description' to name the repository.
summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
Diffstat (limited to 'git-diff.sh')
-rwxr-xr-xgit-diff.sh20
1 files changed, 19 insertions, 1 deletions
diff --git a/git-diff.sh b/git-diff.sh
index b3ec84be69..b62e58341c 100755
--- a/git-diff.sh
+++ b/git-diff.sh
@@ -7,7 +7,10 @@ rev=$(git-rev-parse --revs-only --no-flags --sq "$@") || exit
flags=$(git-rev-parse --no-revs --flags --sq "$@")
files=$(git-rev-parse --no-revs --no-flags --sq "$@")
-: ${flags:="'-M' '-p'"}
+die () {
+ echo >&2 "$*"
+ exit 1
+}
# I often say 'git diff --cached -p' and get scolded by git-diff-files, but
# obviously I mean 'git diff --cached -p HEAD' in that case.
@@ -20,6 +23,21 @@ case "$rev" in
esac
esac
+# If we do not have --name-status, --name-only nor -r, default to -p.
+# If we do not have -B nor -C, default to -M.
+case " $flags " in
+*" '--name-status' "* | *" '--name-only' "* | *" '-r' "* )
+ ;;
+*)
+ flags="$flags'-p' " ;;
+esac
+case " $flags " in
+*" '-"[BCM]* | *" '--find-copies-harder' "*)
+ ;; # something like -M50.
+*)
+ flags="$flags'-M' " ;;
+esac
+
case "$rev" in
?*' '?*' '?*)
echo >&2 "I don't understand"